<?php

namespace PME\Controllers;

use Symfony\Component\Config\FileLocator;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DataSource\DataSet;
use PME\Util\Messages;

class LoginController {
    
    private $connection;
    private $environment;
    private $session;
    private $productId;
    private $loginUrl;
    private $productPath;
    protected $errorCode = [
		"ORA-01017" => "ERROR_SENHAUSUARIONEGADO"
	];
    
    public function __construct($connection, $environment, $session, $productId, $loginUrl, $productPath) {
        $this->connection = $connection;
        $this->environment = $environment;
        $this->session = $session;
        $this->productId = $productId;
        $this->loginUrl = $loginUrl;
        $this->productPath = $productPath;
    }
    
    public function userInfo(Request\Row $request, Response $response) {
        $userInfo = [];
        $sessionInfo = $this->session->get("LOGIN_USER_INFO");
        if(!empty($sessionInfo) && !empty($sessionInfo['USER_DATA'])) {
            $cdfilial = isset($sessionInfo['USER_DATA']['OTHER_SESSION_VALUES']['CDFILIAL']);
            $nmfilial = isset($sessionInfo['USER_DATA']['OTHER_SESSION_VALUES']['NMFILIAL']);
            $nmacesso = isset($sessionInfo['USER_DATA']['OTHER_SESSION_VALUES']['NMACESSO']);
            
            $userInfo = [
                "CDFILIALSELECIONADA" => $cdfilial == true ? $sessionInfo['USER_DATA']['OTHER_SESSION_VALUES']['CDFILIAL'] : '',
                "NMFILIAL" => $nmfilial == true ? $sessionInfo['USER_DATA']['OTHER_SESSION_VALUES']['NMFILIAL'] : '',
                "CDPICTPROD" => $sessionInfo['USER_DATA']['OTHER_SESSION_VALUES']['CDPICTPROD'],
                "CDPICTPRAT" => $sessionInfo['USER_DATA']['OTHER_SESSION_VALUES']['CDPICTPRAT'],
                "NMACESSO" => $nmacesso == true ? $sessionInfo['USER_DATA']['OTHER_SESSION_VALUES']['NMACESSO'] : ''
            ];
        }
        $response->addDataSet(new DataSet('userInfo', $userInfo));
    }

}