<?php
namespace Fiscal\Repositories;

class Trabimposnftot extends \Doctrine\ORM\EntityRepository
{
    public function insertImpostosTemporariosDaImposnftot($cdfilial, $nrlanctonf, $nrorg){
        $sql = <<<SQL
        INSERT INTO TRABIMPOSNFTOT
               (CDFILIMPTOT, NRLANCIMPTOT, CDIMPOSTOT, VRIMPOSTOT, VRBCALIMPTOT)

            (SELECT CDFILIAL, NRLANCTONF, CDIMPOSTO, VRTOTIMPONF, VRTOTBCALCNF
               FROM IMPOSNFTOT
              WHERE CDFILIAL   = :P_CDFILIAL AND
                    NRLANCTONF = :P_NRLANCTONF AND
                    NRORG      = :P_NRORG)
SQL;

        $params = array(
            'P_CDFILIAL'      => $cdfilial,
            'P_NRLANCTONF'   => $nrlanctonf,
            'P_NRORG'      => $nrorg
        );

        return $this->getEntityManager()->getConnection()->executeUpdate($sql, $params);
    }

    public function getImpostoRetido($cdfilial, $nrlanctonf, $nrorg, $nrdectotanf){
        $sql = <<<SQL
        SELECT ROUND(NVL(SUM(T.VRIMPOSTOT),0),:P_NRDECTOTANF) AS VRIMPOSTOT
         FROM TRABIMPOSNFTOT T, IMPOSTO I
         WHERE T.CDFILIMPTOT  = :P_CDFILIAL    AND
               T.NRLANCIMPTOT = :P_NRLANCTONF  AND
               T.NRORG        = :P_NRORG      AND
               T.CDIMPOSTOT   = I.CDIMPOSTO   AND
               I.IDTRATIMPO   = 'R'           AND
               I.IDDESCRFONTE = 'R'
SQL;

        $params = array(
            'P_CDFILIAL'      => $cdfilial,
            'P_NRLANCTONF'   => $nrlanctonf,
            'P_NRORG'      => $nrorg,
            'P_NRDECTOTANF'      => $nrdectotanf
        );

        return $this->getEntityManager()->getConnection()->fetchColumn($sql, $params);
    }

    public function save($params){
        $sql = "INSERT INTO TRABIMPOSNFTOT
                            (CDFILIMPTOT, NRLANCIMPTOT, CDIMPOSTOT, VRIMPOSTOT, IDERROSTOT, IDAVISOSTOT, VRBCALIMPTOT)
                     VALUES (?,?,?,?,?,?,?)";
        $connection = $this->getEntityManager()->getConnection();
        return $connection->executeUpdate($sql,$params);
    }
}